<?php

/*
 * @package RS-SITE
 * @copyright (c) 2013 Alexey Glumov aka Rio-Shaman (support@rio-shaman.ru)
 * @license GNU General Public License version 2; see LICENSE.txt
 *
 */
 

if(!defined('RS-SITE')) die();

class groupaccess extends core
{
    /*инициализация объектов для работы данного класса*/
    function groupaccess($value)
    {
        $this->core();
        $this->page = (isset($_GET['page'])) ? $this->tools->clear_int($_GET['page']) : 1;
        $this->rc   = $value['rc'];
    }
    
    /* CASE : BROWSE */
    
    /* получаем все шаблоны */
    function get_group()
    {
        $param = array(
            'modul'    => 'access_group',// вообще это имя таблицы без приставки rs_
            'rc'       => $this->rc,
            'page'     => $this->page
        );        
        
        $navigation = $this->navigation->set_navigation($param);
        
        $sql = "SELECT * FROM rs_access_group ORDER BY group_id DESC"
              ." LIMIT ".$navigation['navigation']['rc']." OFFSET ".$navigation['navigation']['offset'];
              
        if (!$group = $this->db->accept_select($sql))
            return FALSE;
        
        return array('group' => $group, 'navigation' => $navigation['navigation']);
    }
    
    /* CASE : ADD */
    
    function add_group(&$fields)
    {
        // проверка пустое ли имя
        if (empty($fields['group_name']))
        {
            $fields['error'][0] = "Пустое поле";
            return FALSE;
        }
        
        // проверка пустой ил псевдоним
        if (empty($fields['group_alias']))
        {
            $fields['error'][1] = "Пустое поле";
            return FALSE;
        }        
        
        // проверка уникальности псевдонима
        $sql = "SELECT * FROM rs_access_group WHERE group_alias='".$fields['group_alias']."'";
        
        if ($group = $this->db->accept_select($sql))
        {
            $fields['error'][2] = "Такая группа уже существует";
            return FALSE;
        }
        
        $what = array(
            'group_name'       => $fields['group_name'],
            'group_alias'      => $fields['group_alias']
        );

        $this->db->accept_insert($what, 'rs_access_group');

        $this->tools->move_to('/admin/group-access/');
    }
    
    /* CASE : EDIT */
    
    function show_edit_form($group_id)
    {
        $sql = "SELECT * FROM rs_access_group WHERE group_id='".$group_id."'";
        
        if (!$groups = $this->db->accept_select($sql))
            return array();
            
        return $groups[0];
    }
    
    function edit_group(&$fields)
    {
        // проверяем есть ли редактируемая группа в БД
        $sql = "SELECT * FROM rs_access_group WHERE group_id='".$fields['group_id']."'";
        
        if (!$group = $this->db->accept_select($sql))
        {
            $fields['error'][3] = "Системная ошибка";
            return FALSE;            
        }
        
        // проверка пустое ли имя
        if (empty($fields['group_name']))
        {
            $fields['error'][0] = "Пустое поле";
            return FALSE;
        }

        // проверка пустой ил псевдоним
        if (empty($fields['group_alias']))
        {
            $fields['error'][1] = "Пустое поле";
            return FALSE;
        }        
        
        // проверка уникальности псевдонима
        if ($group[0]['group_alias'] != $fields['group_alias'])
        {
            $sql = "SELECT * FROM rs_access_group WHERE group_alias='".$fields['group_alias']."'";
            
            if ($group = $this->db->accept_select($sql))
            {
                $fields['error'][2] = "Такая группа уже существует";
                return FALSE;
            }
        }
        
        $what = array(
            'group_name'       => $fields['group_name'],
            'group_alias'      => $fields['group_alias']
        );

        $this->db->accept_update($what, 'rs_access_group', "group_id='".$fields['group_id']."'");

        $this->tools->move_to('/admin/group-access/');
    }
    
    /* CASE : DELETE */
    
    function delete_group($group_id)
    {
        $sql = "SELECT * FROM rs_access_group WHERE group_id='".$group_id."'";

        if (!$group = $this->db->accept_select($sql))
            die('no group');

        $sql = "DELETE FROM rs_access_user WHERE group_id='".$group_id."'";
        $this->db->accept_delete($sql);

        $sql = "DELETE FROM rs_access_group WHERE group_id='".$group_id."'";
        $this->db->accept_delete($sql);
    }
    
    /* CASE : NBROWSE */
    
    function get_nesting($group_id)
    {
        $param = array(
            'modul'    => 'access_user',// вообще это имя таблицы без приставки rs_
            'rc'       => $this->rc,
            'page'     => $this->page
        );        
        
        $navigation = $this->navigation->set_navigation($param);
        
        $sql = "SELECT"
                ." a.access_id as access_id, u.user_name as user_name, u.user_login as user_login, u.user_access as user_access"
            ." FROM rs_access_user a, rs_user u"
            ." WHERE 1=1"
                ." AND a.user_id=u.user_id"
                ." AND a.group_id='".$group_id."'"
                ." ORDER BY group_id DESC"
                ." LIMIT ".$navigation['navigation']['rc']." OFFSET ".$navigation['navigation']['offset'];
              
        if (!$users = $this->db->accept_select($sql))
            return array('group_id'    => $group_id);

        $access_array = array(
            0    => 'Гость',
            1    => 'Пользователь',
            2    => 'Оператор',
            3    => 'Администратор',
            4    => 'Разработчик'
        );
        
        foreach ($users as $key => $user)
            $users[$key]['user_access'] = $access_array[$users[$key]['user_access']];
        
        return array('users' => $users, 'navigation' => $navigation['navigation'], 'group_id'    => $group_id);        
    }
    
    /* CASE : NADD */
    
    function get_users($group_id)
    {
        $sql = "SELECT * FROM rs_user";
        
        if (!$users = $this->db->accept_select($sql))
            return array();        
        
        $sql = "SELECT * FROM rs_access_user WHERE group_id='".$group_id."'";

        if (!$check_users = $this->db->accept_select($sql))
            return $users;
        
        $user_array = array();
            
        foreach ($check_users as $user)
            $user_array[] = $user['user_id'];
            
        foreach ($users as $key => $user)
            if (in_array($user['user_id'], $user_array))
                unset($users[$key]);
                
        return $users;
    }
    
    function add_user(&$fields)
    {
        // проверяем наличие группы
        $sql = "SELECT * FROM rs_access_group WHERE group_id='".$fields['group_id']."'";
        
        if (!$group = $this->db->accept_select($sql))
        {
            $fields['error'][0] = "Не такой группы";
            return FALSE;
        }
        
        // проверяем наличие пользователя в группе
        $sql = "SELECT * FROM rs_access_user WHERE group_id='".$fields['group_id']."' AND user_id='".$fields['user_id']."'";
        
        if ($auser = $this->db->accept_select($sql))
        {
            $fields['error'][1] = "Такой пользователь уже существует в данной группе";
            return FALSE;
        }
        
        $sql = "SELECT * FROM rs_user WHERE user_id='".$fields['user_id']."'";
        
        if (!$user = $this->db->accept_select($sql))
        {
            $fields['error'][2] = "Такого пользователя нет в БД";
            return FALSE;
        }
        
        $what = array(
            'group_id'    => $fields['group_id'],
            'user_id'     => $fields['user_id']
        );
        
        $this->db->accept_insert($what, 'rs_access_user');

        $this->tools->move_to('/admin/group-access/nesting/?group_id='.$fields['group_id']);
    }
    
    /* CASE : NDELETE */
    
    function delete_user($access_id)
    {
        $sql = "SELECT * FROM rs_access_user WHERE access_id='".$access_id."'";

        if (!$user = $this->db->accept_select($sql))
            die('no user');
            
        $sql = "DELETE FROM rs_access_user WHERE access_id='".$access_id."'";
        
        $this->db->accept_delete($sql);
    }
}
?>