<?php

/*
 * @package RS-SITE
 * @copyright (c) 2013 Alexey Glumov aka Rio-Shaman (support@rio-shaman.ru)
 * @license GNU General Public License version 2; see LICENSE.txt
 *
 */
 

if(!defined('RS-SITE')) die();

class mostcomm extends core
{
    function mostcomm($value)
    {
        $this->core();
        $this->type   = $value['type'];
        $this->root   = $value['tree'];
        $this->limit  = $value['limit'];
        $this->suffix = $value['suffix'];
    }

    function get_mostcomm()
    {
        if($cache = $this->cache->readerCACHE('mostcomm', $_GET['chpu_links'], 1*60*60, TRUE))
            return $cache;

        $sql = ""
            ."SELECT"
                ." c.content_id           AS content_id,"
                ." c.map_id               AS map_id,"
                ." m.map_alias            AS content_alias,"
                ." c.content_title        AS content_title,"
                ." c.content_publication  AS content_publication,"
                ." c.catalog_id           AS catalog_id,"
                ." f.field_logo           AS field_logo,"
                
                ." ("
                ."    SELECT"
                          ." COUNT(*)"
                      ." FROM"
                          ." rs_comment comment "
                      ."WHERE"
                          ."     comment.content_id                 =  c.content_id"
                          ." AND YEAR(comment.comment_publication)  >= '".date('Y')."'"
                          ." AND MONTH(comment.comment_publication) >= '".date('n')."'"
                ." )"
                ."                        AS comment_count"
            ." FROM"
                ." rs_content c,"
                ." rs_map m,"
                ." rs_".$this->type."_".$this->suffix." f"
            ." WHERE"
                ." c.content_type                         = '".$this->type."'"
                ." AND c.map_id                           = m.map_id"
                ." AND c.content_view                     = '0'"
                ." AND c.content_mode_publication         = '1'"
                ." AND c.content_more                     = f.group_id"
            ." ORDER BY comment_count DESC, c.content_num_comm DESC LIMIT ".$this->limit;
        // 
        if (!$post = $this->db->accept_select($sql))
            return FALSE;
        
        foreach($post as $key => $value)
        {
            if (!preg_match("/^.*?\.html$/", $post[$key]['content_alias']))
                $post[$key]['content_alias'] = $post[$key]['content_alias'].'/';
            
            // формируем ссылку
            $path = array();
            $this->tools->get_parents_dir($value['catalog_id'], $this->root, $path);
            
            $post[$key]['content_link']         = implode('/', array_reverse($path));
            // формируем дату
            $post[$key]['content_publication']  = $this->tools->change_date($value['content_publication']);
            
            foreach ($GLOBALS['rssite']['cachecatalog'][$this->root] as $k => $station)
                if ($station['id'] == $value['catalog_id'])
                {
                    $post[$key]['catalog_name']  = $station['title'];
                    break;
                }
        }

        $this->cache->writeCACHE('mostcomm', $_GET['chpu_links'], $post, TRUE);
        
        return $post;
    }
}
?>