<?php

/*
 * @package RS-SITE
 * @copyright (c) 2013 Alexey Glumov aka Rio-Shaman (support@rio-shaman.ru)
 * @license GNU General Public License version 2; see LICENSE.txt
 *
 */
 

if(!defined('RS-SITE')) die();

class search extends core
{
    function search($value)
    {
        $this->core();
        $this->content          = (!is_array($value['content'])) ? array($value['content']) : $value['content'];
        //$this->comment        = (!is_array($value['comment'])) ? array($value['comment']) : $value['comment'];
        $this->rc               = $value['rc'];
        $this->page             = (isset($_GET['page'])) ? $this->tools->clear_int($_GET['page']) : 1;
        $this->suffix           = $value['suffix'];
        $this->page_id          = $value['page'];
    }

    function start_search($string)
    {
        $demands = explode(' ', $string);
        
        // удаляем поисковые слова которые меньше 4-х символов
        foreach ($demands as $key => $value)
            if (!$this->clearStringLength($value))
                unset($demands[$key]);

        // чистим от окончания слов
        foreach ($demands as $key => $value)
            $demands[$key] = $this->clearStringBack($value);
        
        // чистим от стоп-слов
        foreach ($demands as $key => $value)
            $demands[$key] = $this->clearStringStop($value);
            
        $search_result = array();
        
        if ($contents = $this->content_request($demands))
            foreach ($contents as $content)
                $search_result[] = array(
                    'title'       => $content['content_title'],
                    'desc'        => $content['content_desc'],
                    'key'         => $content['content_key'],
                    'text'        => strip_tags($content['content_announce'].$content['content_text']),
                    'alias'       => $content['content_alias'],
                    'catalog'     => $content['catalog_id'],
                    'additional'  => $content['content_more'],
                    'type'        => $content['content_type'],
                    'publication' => $content['content_publication'],
                    'login'       => $content['user_login'],
                    'comm'        => $content['content_comm'],
                    'ranking'     => 0
                );
                
        $this->get_ranking($search_result, $demands);
        $this->get_snippet($search_result, $demands);
        $this->highlight_query($search_result, $demands);
        $this->sort_result($search_result);
        $this->get_navigation($search_result);
        
        // перебрасываем ключи
        $search = array();
        
        foreach ($search_result as $search_array)
            $search[] = $search_array;
            
        unset($search_array);
        
        // поиск типов контента в результате поиска
        $this->get_type($search);
        // получаем значение доп полей (и сами поля естественно)
        $this->get_additional_fields($search);
        
        foreach($search as $key => $value)
        {
            if (!preg_match("/^.*?\.html$/", $search[$key]['alias']))
                $search[$key]['alias'] = $search[$key]['alias'].'/';

            $root = $this->get_root($value['catalog']);

            $search[$key]['publication']  = $this->tools->change_date($value['publication']);
            
            if (empty($root))
                continue;
            
            $path = array();
            $this->tools->get_parents_dir($value['catalog'], $root, $path);
            
            $search[$key]['link']         = implode('/', array_reverse($path));

            foreach ($GLOBALS['rssite']['cachecatalog'][$root] as $k => $station)
                if ($station['id'] == $value['catalog'])
                {
                    $search[$key]['catalog_name']  = (empty($station['link'])) ? $station['name'] : '';
                    break;
                }
        }
        
        $result['search']       = $search;
        $result['navigation']   = $this->param;
        
        return $result;
    }
    
    /* методы чистки поисковых слов */
        
    function clearStringLength($string)
    {
        $string = iconv('UTF-8', 'windows-1251', $string);

        if (strlen($string) < 4)
            return FALSE;
            
        return TRUE;
    }
    
    function clearStringBack($string)
    {
        $reg     = "/(ый|ой|ая|ое|ые|ому|а|о|у|е|ого|ему|и|ство|ых|ох|ия|ий|ь|я|он|ют|ат)$/ui";
        $string  = preg_replace($reg,'',$string);
        
        return $string;
    }
    
    function clearStringStop($string)
    {
        $reg     = "/\s(под|много|что|когда|где|или|которые|поэтому|все|будем|как)\s/ui";
        $string  = preg_replace($reg,'',$string);
        
        return $string;
    }
    
    function clearStringSymbol($string)
    {
        $reg     = "/\s(&nbsp;)\s/ui";
        $string  = preg_replace($reg,'',$string);
        
        return $string;
    }

    /* Запросы в БД */
    function content_request($demands)
    {
        // обрабатываем типы контента
        foreach ($this->content as $key => $type)
            $this->content[$key] = "'".$type."'";
        
        // собираем условия like
        $where = array();

        $fields = array(
            'content.content_text',
            'content.content_title',
            'content.content_desc',
            'content.content_key',
            'content.content_announce',
            'content.content_text'
        );
        
        foreach ($demands as $query)
            foreach ($fields as $field)
                $where[] = $field." LIKE '%".$query."%'";

        $sql = ""
            ."SELECT "
                ." content.content_id as content_id,"
                ." content.content_title as content_title,"
                ." content.content_desc as content_desc,"
                ." content.content_key as content_key,"
                ." content.content_announce as content_announce,"
                ." content.content_text as content_text,"
                ." content.catalog_id as catalog_id,"
                ." content.content_more as content_more,"
                ." content.content_type as content_type,"
                ." content.content_publication as content_publication,"
                ." content.content_num_comm as content_comm,"
                
                ." user.user_login as user_login,"
                
                ." map.map_alias as content_alias"
            ." FROM"
                ." rs_content content,"
                ." rs_map map,"
                ." rs_user user"
            ." WHERE 1=1"
                //." AND content.content_id = 42"
                ." AND content.map_id = map.map_id"
                ." AND content.content_type IN (".implode(',', $this->content).")"
                ." AND (".implode(' OR ', $where).")"
                ." AND content.content_mode_publication = '1'"
                ." AND content.user_id = user.user_id"
                ." AND content.content_id <> '".$this->page_id."'"
        ;

        if (!$result = $this->db->accept_select($sql))
            return FALSE;
        
        return $result;
    }

    /* Ранжирование */
    
    function get_ranking(&$search_result, $demands)
    {
        $table_rank = array(
            'title'    => 100,
            'key'      => 10,
            'desc'     => 10,
            'text'     => 1
        );
        
        foreach ($search_result as $key => $array)
        {
            $rank = 0;
            
            foreach ($demands as $query)
            {
                $reg = array(
                    'search'    => "/".$query."/ui",
                    'save'      => "/(".$query.")/ui"
                ); 
                
                foreach ($array as $field => $value)
                    if (isset($table_rank[$field]))
                        if (!empty($value))
                            if (preg_match($reg['search'], $value))
                            {
                                preg_match_all($reg['save'], $value, $count);
                                
                                $rank += ( $table_rank[$field] * count($count[1]) );
                            }
            }
            
            $search_result[$key]['ranking'] = $array['ranking'] + $rank;
        }
    }
    
    /* Формируем снипет */
    function get_snippet(&$search_result, $demands)
    {
        // я отыскивая в тексте поисковые слова, вырезал их из текста, вместе с 100 симвлами до поискового слова, и 100 после
        // таким образом я избавляюь от дублей снипетов
        foreach ($search_result as $key => $array)
        {
            // попытка сформировать снимет из обрывков текста
            foreach ($demands as $query)
                if (!empty($array['text']))
                {
                    if (!strpos($array['text'], $query))
                        continue;
                    
                    $query          = iconv('UTF-8', 'windows-1251', $query); // изменяем кодировку для поискового слова
                    $array['text']  = iconv('UTF-8', 'windows-1251', $array['text']); // изменяем кодировку для текста
                    
                    $position = strpos($array['text'], $query); // определяем позицию поискового слова
                    
                    $position = ( ($position - 100) <= 0 ) ? 0 : $position - 100; // высчитываем область для вырезания
                    
                    $snippet        = substr($array['text'], $position, 100 * 2 + strlen($query)); // сохраняем снипет
                    
                    $snippet        = iconv('windows-1251', 'UTF-8', $snippet);// возвращаем кодировку для снипета
                    $array['text']  = iconv('windows-1251', 'UTF-8', $array['text']); // возвращаем кодировку для текста

                    $array['text']  = str_replace($snippet, "", $array['text']);// вырезаем снипет из текста
                    
                    // чистим снипет от нежелательных символов
                    $snippet = $this->clearStringSymbol($snippet);

                    $search_result[$key]['snippet'][] = ( ($position != 0) ? '...' : '' ).$snippet.'...'; // записываем снипет
                }
            
            // берем за снипет первые 204 символа
            if (!isset( $search_result[$key]['snippet']))
            {
                $array['text']  = iconv('UTF-8', 'windows-1251', $array['text']);
                $snippet        = substr($array['text'], 0, 100 * 2 + 4);
                $snippet        = iconv('windows-1251', 'UTF-8', $snippet);
                
                $search_result[$key]['snippet'][] = $snippet.'...'; // записываем снипет 
            }
            
            unset($search_result[$key]['text']);// удаляем текст
        }
    }
    
    /* подсветка поисковых слов */
    function highlight_query(&$search_result, $demands)
    {
        $fields = array(
            'title',
            'snippet'
        );
        
        foreach ($search_result as $key => $array)
            foreach ($fields as $field)
                if ($field == 'snippet')
                {
                    if (!empty($array['snippet']))
                        foreach ($array['snippet'] as $snippet_key => $snippet)
                            foreach ($demands as $query)
                            {
                                $reg = "/(".$query.")/ui";
                                $search_result[$key]['snippet'][$snippet_key] = preg_replace($reg, '<strong>'.$query.'</strong>', $search_result[$key]['snippet'][$snippet_key]);
                            }                    
                }
                else
                    if (!empty($array[$field]))
                        foreach ($demands as $query)
                        {
                            $reg = "/(".$query.")/ui";
                            $search_result[$key][$field] = preg_replace($reg, '<strong>'.$query.'</strong>', $search_result[$key][$field]);
                        } 
    }

    /* сортируем по ранжированию */
    function sort_result(&$search_result)
    {
        $sort = array();
        
        $i     = 0;
        $max   = 0;
        
        usort($search_result, array('search', 'f_sort'));
    }
    
    static function f_sort($a, $b)
    {
        if ($a['ranking'] == $b['ranking'])
            return 0;
        
        return ($a['ranking'] > $b['ranking']) ? -1 : 1;
    }
    
    /* обрезаем массив, выводя лишь элементы страницы */
    function get_navigation(&$search_result)
    {
        $count = count($search_result);
        
        $pagination = (($count - 1) / $this->rc) + 1;
        $pagination = intval($pagination);
        $position   = $this->page * $this->rc - $this->rc;
        
        $limit = array(
            'start'    => ($this->page - 1) * $this->rc,
            'end'      => ($this->page * $this->rc) - 1
        );

        foreach ($search_result as $key => $value)
            if ((int)$key < (int)$limit['start'] OR (int)$key > (int)$limit['end'])
                unset($search_result[$key]);
                
        $this->param = array(
            'offset'      => $position,
            'page'        => $this->page,
            'rc'          => $this->rc,
            'pagination'  => $pagination
        );
    }

    /* определяем типы контента */
    function get_type($search)
    {
        $this->type = array();
        
        foreach ($search as $key => $value)
            if (empty($this->type))
                $this->type[] = $value['type'];
            else
                if (!in_array($value['type'], $this->type))
                    $this->type[] = $value['type'];
    }
    
    /* выводим значение дополнительных полей */
    function get_additional_fields(&$search)
    {
        // по типу контента можно определить группу полей (rs_fields_group)
        if(!$groups_id = $this->get_group())
            return FALSE;

        // по группе можно определить алиасы доп полей (rs_fileds)
        if (!$fields_alias = $this->get_aliases_fields($groups_id))
            return FALSE;

        // зная тип, группу и алиас поля можно определить таблицу (rs_тип_$this->suffix) и имя поля с значением (что в общем то нам и нужно)
        if (!$value_fields = $this->get_value_fields($fields_alias, $search))
            return FALSE;
        
        foreach ($search as $search_key => $value)
            foreach ($value_fields[$value['type']] as $key => $array)
                if ($array['group_id'] == $value['additional'])
                    foreach ($array as $field => $val)
                        if ($field != 'group_id')
                            $search[$search_key][$field] = $val;
    }
    
    function get_value_fields($fields_alias, $search)
    {
        $result = array();
        
        foreach ($fields_alias as $type => $alias_array)
        {
            $fields = $groups = array();
            
            // определяем выводимые поля
            foreach ($alias_array as $key => $alias)
                $fields[] = " f.field_".$alias." as field_".$alias;
            
            //определяем выводимые группы (additional)
            foreach ($search as $key => $value)
                if ($value['type'] == $type)
                    $groups[] = "'".$value['additional']."'";
            
            $sql = ""
                ."SELECT "
                    ." f.group_id as group_id,"
                    .implode(',', $fields)
                ." FROM"
                    ." rs_".$type."_".$this->suffix." f"
                ." WHERE 1=1"
                    ." AND f.group_id IN (".implode(',', $groups).")"
            ;

            if (!$val = $this->db->accept_select($sql))
                return FALSE;
                
            $result[$type] = $val;
        }
        
        return $result;
    }
    
    function get_aliases_fields($groups_id)
    {
        $group_id = array();
        
        foreach ($groups_id as $key => $value)
            $group_id[] = "'".$value['group_id']."'";

        $sql = ""
            ."SELECT "
                ." f.field_alias as field_alias,"
                ." f.group_id as group_id"
            ." FROM"
                ." rs_fields f"
            ." WHERE 1=1"
                ." AND f.group_id IN (".implode(',', $group_id).")"
        ;

        if (!$result = $this->db->accept_select($sql))
            return FALSE;

        $fields_alias = array();

        foreach ($result as $key => $value)
            foreach ($groups_id as $group_key => $group_value)
                if ($group_value['group_id'] == $value['group_id'])
                    $fields_alias[$group_value['group_alias']][] = $value['field_alias'];
        
        return $fields_alias;
    }
    
    function get_group()
    {
        $type = array();
        
        if (!empty($this->type))
            foreach ($this->type as $key => $value)
                $type[] = "'".$value."'";
        
        if (empty($type))
            return FALSE;
        
        $sql = ""
            ."SELECT "
                ." g.group_id as group_id,"
                ." g.group_alias as group_alias"
            ." FROM"
                ." rs_fields_group g"
            ." WHERE 1=1"
                ." AND g.group_alias IN (".implode(',', $type).")"
        ;

        if (!$groups_id = $this->db->accept_select($sql))
            return FALSE;
            
        return $groups_id;
    }

    /* Ищем узел в каталоге */
    function get_root($catalog_id)
    {
        $root = '';
        
        foreach ($GLOBALS['rssite']['cachecatalog'] as $key => $catalogs)
            foreach ($catalogs as $catalog)
                if ($catalog['id'] == $catalog_id)
                {
                    if (!empty($catalog['link']))
                        return array();
                    
                    $root = $key;
                    break; break;
                }
        
        return $root;
    }

    function get_meta()
    {
        // выводим метатеги страницы
        $sql = "SELECT content_title, content_desc, content_key FROM rs_content WHERE content_id = '".$this->page_id."'";
        
        if ($page = $this->db->accept_select($sql))
            $GLOBALS['rssite']['cfg']['meta']['two'] = array(
                'meta_title'        => $page[0]['content_title'],
                'meta_desc'         => $page[0]['content_desc'],
                'meta_key'          => $page[0]['content_key']
            );
    }
}
?>